require 'redlock'

module HttpThreshold
  class Client

    class << self
      def throttles
        @throttles  ||= {}
      end

      def cache
        @cache ||= Cache.new
      end

      def lock_manager
        @lock_manager ||= Redlock::Client.new([Redis.new(:url => HttpThreshold.redis_url)])
      end

      def incr_count(domain)
        self.throttles[domain].try(:incr_count)
      end

      def set_throttle(domain, options = {})
        self.throttles[domain] = HttpThreshold::Throttle.new(domain, options)
      end

      def sleep_until_allowed(host)
        throttle = self.throttles[host]
        if throttle
          if !throttle.incr_count
            puts "#{host} reach threshold limit"
            sleep 0.25

            while !throttle.incr_count
              sleep 0.25
            end
          end
          yield
        else
          yield
        end
      end
    end

  end
end